<template>
        <v-card class="inspector-form">
            <v-card-title>
                <template>
                    <slot name="title">
                        <v-flex xs10>
                            <span class="subheading">{{title}}</span>
                        </v-flex>
                        <v-flex xs2 class="text-xs-right" v-if="editable && !edit">
                            <v-icon small color="primary" @click="startEdit">edit</v-icon>
                        </v-flex>
                        <v-flex xs2 class="text-xs-right" v-if="edit">
                            <v-icon small color="primary"  @click="endEdit">save</v-icon>
                        </v-flex>
                    </slot>
                </template>
            </v-card-title>
            
            <v-divider v-if="divider"/>
            
            <v-card-text>
                <v-layout row v-for="(val, key) in filteredSource" :key="key">
                    <v-flex xs5>
                        <template>
                            <slot name="key" v-bind:item="{key, val}">
                                 <span  class="ellipsis">{{keyMap[key]}}</span>
                            </slot>
                        </template>
                    </v-flex>
                    
                    <v-flex xs7 d-flex>
                        <template>
                            <slot name="value" v-bind:item="{key, val}">
                                <v-switch 
                                    v-if="switches.indexOf(key)>=0" 
                                    v-model="source[key]"
                                    class="pa-0 ma-0" 
                                    height="16px" 
                                    :readonly="!edit"></v-switch>
                                <span v-if="switches.indexOf(key)<0 && !edit" class="ellipsis" :title="prop(key)">
                                    {{ transformer ? transformer(key, source[key]) : source[key] }}
                                </span>
                                
                                <span class="pa-0 ma-0 dense-inputs">
                                    <v-text-field
                                        :autofocus="key==autofocus"
                                        class="pa-0 ma-0" 
                                        @keydown.ctrl.enter="endEdit()"
                                        @keydown.esc="cancelEdit()"  
                                        v-if="switches.indexOf(key)<0 && !!edit"
                                        v-model.lazy="source[key]"
                                        browser-autocomplete='off'/>
                                </span>
                            </slot>
                        </template>
                    </v-flex>
                </v-layout>
            </v-card-text>
            
        </v-card>
</template>

<script>
export default {
  name: 'ObjectInspector',
  props: {
    showAll: null,
    log: null,
    value: Object, 
    divider: Boolean, 
    autofocus: String,
    title: String, 
    editable: Boolean,
    transformer: Function,
    keyMap: {
        type: Object,
        default: () => { }
    },
    switches: {
        type: Array,
        default: () => []
    }
  },
  data() {
    return {
        edit: false,
        source: this.value || { }
    }
  },
  computed: {
    filteredSource() {
        let filtered = { }
        for ( let key in this.keyMap ) {
            const val = this.source[key]
            if ( this.showAll || this.isVisible(key, val) ) {
                filtered[key] = val
            }
        }
        return filtered;
    }
  },
  methods: {
    startEdit()  {
        this.originalSource = Object.assign({}, this.source)
        this.edit = true;
    },
    endEdit() {
        this.$emit('input', this.source)
        this.edit = false;
        delete this.originalSource
    },
    cancelEdit() {
        this.edit = false;
        this.source = Object.assign({}, this.originalSource)
        delete this.originalSource
    },
    isVisible(key, val) {
        return !!this.keyMap[key] && (!!val || this.switches.indexOf(key) >= 0)
    },
    prop(key) {
        return this.transformer ? this.transformer(key, this.source[key]) : this.source[key]
    }
  }
}
</script>

<style>
.inspector-form .v-messages {
  display: none;
}
.inspector-form>.v-text-field>.v-input__control>.v-input__slot:before {
  margin-bottom: 1px #ddd dashed;
}
</style>
